-- -- Invas0res -- --
-- Author   : Leo M. Cabrera
-- E-mail   : leo28c@gmail.com
-- Date     : March 18, 2007
-- Version  : Beta 4
-- File     : (5/7) funcs.lua
-- Does     : Most of the game logic functions

function shoot(g)
	for b = 1, maxBullets do
		if not playerBullet[b].active then
		-- Shoot it!
			playerBullet[b].x = ship.x + gun[g].x + math.random(-3, 3)
			playerBullet[b].y = ship.y + gun[g].y + math.random(-3, 3)
			playerBullet[b].active = true
			s_shoot:play()
			return
		end
	end
end -- shoot()


-- FIXME: Why won't bullets[b].x/y work here?
function breakShield(x, b, type)

	-- Player = start at bottom, end at top (-1 indicates player)
	if type == "player" then
		lStart = shieldsPos.y + shieldsPos.h
		lEnd   = shieldsPos.y
		add = -1

	-- Alien = start at top, end at bottom
	else
		lStart = shieldsPos.y - aBulletImg:height()
		lEnd   = shieldsPos.y + shieldsPos.h
		add = 1
	end

	-- Start at lStart
	y = lStart

	-- Work all the way to the top (or bottom if an alien bullet)
	repeat
		-- If a shield pixel was hit,
		if x > 0 and 
		   x < scrWidth and
		   shieldsLyr:pixel(x, y) ~= transp then
			-- Make a hole in it!
			if b == -1 then
				shieldsLyr:fillRect(x-5, y-5, 10, 10, transp)
			else
				shieldsLyr:fillRect(x-5, y-5, 10, 10, transp)
			end
			
			-- Bullet no longer active
			if type == "alien" then
				alienBullets[b].active = false
			else 
				playerBullet[b].active = false
			end
			
			break
		end
		y = y + add
	until y == lEnd -- End at lEnd
end


function processBullets()

	-- Process player bullet
	for b = 1, maxBullets do
		playerBullet[b].y = playerBullet[b].y - bulletSpeed
	
		-- Check if it hit a the shields layer
		if playerBullet[b].active and           
			playerBullet[b].y <= shieldsPos.y + shieldsPos.h and
			playerBullet[b].y + bulletImg:height() >= shieldsPos.y then
			breakShield(playerBullet[b].x, b, "player")
		end

		-- Check if the bullet went to the top of the screen
		if playerBullet[b].active and playerBullet[b].y <= 0 then
			playerBullet[b].active = false
		end

		if level == 5 or level == 10 or level == 15 or level == 30 then
	
			-- See if the bullet actually hit (any part of) the alien
			if playerBullet[b].active and
			   playerBullet[b].x >= aliens.lyrXpos.cur and
			   playerBullet[b].x <= aliens.lyrXpos.cur + 300 and
			   playerBullet[b].y <= aliens.lyrYpos.cur + 183 then
				
				playerBullet[b].active = false
		   	
				-- Loop through all the bullets, if it's been hit, 1 less hitpoint
				for l = 32, 262, 23 do
					if playerBullet[b].x >= aliens.lyrXpos.cur + l and
					playerBullet[b].x <= aliens.lyrXpos.cur + l +  7 then
						aliveAliens = aliveAliens - 1
					end
				end
		
				-- If boss life is zero;
				if aliveAliens == 0 then
					-- Get the # of rows and columns
					local cols = math.floor(200 / 24)
					local rows = math.floor(300 / 24)
			
					-- Do the zig-zag explosions
					for y = cols-1, 0, -2 do
						for x = 0, rows-1 do
							aliens.layer:blit(x*math.random(22,26), y*math.random(22,26), aliens.expImg)
							render()
							System.sleep(64)
							s_alienDie:play()
						end
						
						for x = rows-1, 0, -1 do
							aliens.layer:blit(x*math.random(22,26), (y-1)*math.random(22,26), aliens.expImg)
							render()
							System.sleep(64)
							s_alienDie:play()
						end
					end
				
					aliens.layer:blit(0, 0, aliens.bExpImg)
					render()
					s_playerDie:play()
					System.sleep(1000)
					s_playerDie:play()
			
					-- Remove it from the screen
					aliens.layer:fillRect(0, 0, aliens.layer:width(), aliens.layer:height(), transp)
				end
			end
		
		else
			for a = 0, numAliens-1 do
				-- Check if it hit the alien
				if playerBullet[b].active and aliens[a].hp > 0 and
				playerBullet[b].x >= aliens[a].x and
				playerBullet[b].x <= aliens[a].x + aliens.imgW and
				playerBullet[b].y >= aliens[a].y and
				playerBullet[b].y <= aliens[a].y + aliens.imgH then
			   
				-- Destroy the bullet
				playerBullet[b].active = false

				-- TODO: Fix this!
	--		   	-- Not found any aliens on the left (min)
	--			local fminAlive = false
	--			-- Loop through all the aliens to verify that
	--			for l = 0, numAliens-1, 5 do
	--				if aliens[l].alive then fminAlive = true end
	--			end
	--
	--			-- Not found any aliens on the right (max)
	--			local fmaxAlive = false
	--			-- Loop through all the aliens to verify that
	--			for l = numAliens-1, 0, -5 do
	--				if aliens[l].alive then fmaxAlive = true end
	--			end
	--
	--			-- If verified, then increase the minimum position
	--			if not fminAlive then
	--				aliens.lyrXpos.min = aliens.lyrXpos.min - aliens.imgW * 2
	--			end
	--	
	--			-- If verified, then increase the maximum position
	--			if not fmaxAlive then
	--				aliens.lyrXpos.max = aliens.lyrXpos.max + aliens.imgW * 2
	--				score = score + 1000
	--			end
	--
	--			-- If it's just 1 alien left, the above won't work; so we do this:
	--			if aliveAliens == 1 then
	--				aliens.lyrXpos.min = 0
	--				aliens.lyrXpos.max = scrWidth - aliens.imgW
	--			end

					-- Remove 1 hit point from the alien
					-- (This will either kill it or remove its shield; depends on level)
					aliens[a].hp = aliens[a].hp - 1
					
					-- If the alien is fully dead
					if aliens[a].hp == 0 then
						-- Remove the alien from the screen (fill its spot transparent)
						aliens.layer:fillRect(
							aliens[a].x - aliens.lyrXpos.cur,
							aliens[a].y - aliens.lyrYpos.cur * aliens.imgH,
							aliens.imgW,
							aliens.imgH,
							transp)

						-- Draw the explosion
						aliens.layer:blit(
							aliens[a].x - aliens.lyrXpos.cur,
							aliens[a].y - aliens.lyrYpos.cur * aliens.imgH,
							aliens.expImg)
	      		
						-- Start the explosion timer
						aliens.explosions[a].on = true
						aliens.explosions[a].timer:reset(0)
						aliens.explosions[a].timer:start()
						
						aliveAliens = aliveAliens - 1
						s_alienDie:play()
						
					-- Or if just the shield was damaged
					else
						-- Remove the shielded image
						-- Remove the alien from the screen (fill its spot transparent)
						aliens.layer:fillRect(
							aliens[a].x - aliens.lyrXpos.cur,
							aliens[a].y - aliens.lyrYpos.cur * aliens.imgH,
							aliens.imgW,
							aliens.imgH,
							transp)
						
						-- Blit just the alien image
						aliens.layer:blit(aliens[a].x - aliens.lyrXpos.cur,
							aliens[a].y - aliens.lyrYpos.cur * aliens.imgH,
							aliens.img)
						
						-- If the shield isn't completely gone
						if aliens[a].hp > 1 then
							-- Draw the new shield
							aliens.layer:blit(aliens[a].x - aliens.lyrXpos.cur,
								aliens[a].y - aliens.lyrYpos.cur * aliens.imgH,
								aliens.shieldImg[aliens[a].hp-1])
								
						else
							-- Only play the sound if it is completely gone
							s_breakShield:play()
						end
					end

					alienBullets.max = math.min(aliveAliens/2, alienBullets.max)

					-- Add a point
					score = score + 1
				end
			end
		end
	end

	-- Process alien bullets
	for b = 0, alienBullets.max do
		if alienBullets[b].active then
		    alienBullets[b].y = alienBullets[b].y + bulletSpeed

		    -- Check if the bullet went to the bottom of the screen
			if alienBullets[b].active and alienBullets[b].y +
				aBulletImg:height() >= scrHeight then
				alienBullets[b].active = false
			end

			-- Check if it hit the ship and the pixel is not transparent
			if alienBullets[b].active and
			   alienBullets[b].y > ship.y and
			   alienBullets[b].y < ship.y + ship.w and
			   alienBullets[b].x > ship.x and
			   alienBullets[b].x < ship.x + ship.w then
			   --shipImg[1]:pixel(alienBullets[b].x - ship.x, -- TODO:
			   --alienBullets[b].y - ship.y) ~= transp then

				-- Break the shield and take off 1 point
				ship.health = ship.health - 1
				score = score - 1
			   
				if ship.health ~= 0 then
					s_breakShield:play()
				else
					-- You lose if you have no shield (aka health == 0)
					lose()
					return
				end
				
				alienBullets[b].active = false
			end
		end
	
		-- Check if it hit a the shields layer
		if alienBullets[b].active and           
	 	   alienBullets[b].y <= shieldsPos.y + shieldsPos.h and
	   	   alienBullets[b].y + bulletImg:height() >= shieldsPos.y then
		    breakShield(alienBullets[b].x, b, "alien")
		end
	end
end


function removeBullets()
	-- Remove all of the player's bullets from the screen
	for b = 1, maxBullets do
		playerBullet[b].active = false
	end
	
	-- Remove all of the alien bullets from the screen
	for b = 0, alienBullets.max do
	    alienBullets[b].active = false
	end
end


function win()

	-- Takes all of the bullets off-screen
	removeBullets()

	while ship.x < scrWidth/2 + ship.w/2 do
	    ship.x = ship.x + ship.speed
	    processExplosions()
	    render()
	end
	while ship.x > scrWidth/2 + ship.w/2 do
	    ship.x = ship.x - ship.speed
	    processExplosions()
	    render()
	end
	
	while ship.y > 0 - ship.h do
	    ship.y = ship.y - ship.speed * 2
	    processExplosions()
	    render()
	end
	
	-- Give 2 extra lives after a boss battle
	if level == 5 or level == 10 or level == 15 or level == 30 then
		lives = lives + 1
	end

	-- Display the "You Win!" message
	render("win")
	
	-- Increase level
	level = level + 1
	
	-- Reset gameplay; adjusting variables for the new level
	resetGameplay()
		
	-- Pause for 1 second
	System.sleep(1000)
	
	-- Reset the aliens
	loadAliens()
	drawAliens()
	
	-- Recreate the background and place new shields
	createBackground()
	placeShields()

	-- Display intro
	displayIntro()
end -- win()


function lose()

	-- Takes all of the bullets off-screen
	removeBullets()

	-- Explode!
	s_playerDie:play()
	
	-- Game Over if lives < 0
	if lives < 0 then
		game_over()
		-- Let user reselect difficulty
		displayIntro("select difficulty")
		return
		
	-- If not then display the "You Lose!" message
	else
		render("lose")
	end
		
	-- Pause for 2.5 seconds (to give the user time to view the score)
	System.sleep(2500)
	
	-- Display intro again
	displayIntro()
	
	-- Reset gameplay; adjusting variables for the new level
	resetGameplay()
	
	-- Reset the aliens
	loadAliens()
	drawAliens()
	
	-- Recreate the background and place new shields
	createBackground()
	placeShields()
	
	-- Remove 1 life
	lives = lives - 1
end -- lose()


function game_over()

	-- Takes all of the bullets off-screen
	removeBullets()
	
	render("gameover")
	System.sleep(500)
		
	-- Wait for action...
	while true do
		pad = Controls.read()
			
		-- Cross continues; start exits
		if pad:cross() then break end
	end
	
	-- Start from scratch... Sorry, but you suck. >:-P
	level = 1
	score = 0
	
	-- Reset gameplay; adjusting variables for the new level
	resetGameplay()
	
	-- Reset the aliens
	loadAliens()
	drawAliens()
	
	-- Recreate the background and place new shields
	createBackground()
	placeShields()
end -- lose()

function beat()
	-- Create a new background
	createBackground()
	
	-- Load the ending messages
	beat = Image.load("images/congrats.png")
	
	-- Blit them
	screen:blit(0, 0, background)
	screen:blit(scrWidth/2 - beat:width()/2, scrHeight/2 - beat:height()/2, beat)
	
	-- Update the screen
	screen.flip()
	
	-- Wait till the user presses Start to exit the game...
	while true do
		-- Read the controls
		pad = Controls.read()
	
		-- Clean up and exit in case we finish
		if pad:start() then
			cleanUp()
			return true
		end
	end
end
