-- -- Invas0res -- --
-- Author   : Leo M. Cabrera
-- E-mail   : leo28c@gmail.com
-- Date     : March 18, 2007
-- Version  : Beta 4
-- File     : (1/7) index.lua
-- Does     : The game's main loop

-- TODO: Now you do this
--	* Fix the damn crashes!
--	* Check the big TODO comment block at the end of alienShoot()
--	* Check the big TODO comment block in processBullets()
--	* Fix the text centering in displayIntro() (Load an image?)

-- Load the other files
dofile("sound.lua")
dofile("vars.lua")
dofile("funcs.lua")
dofile("render.lua")
dofile("alienfuncs.lua")

if _LPN_ == nil then _LPN_ = false end

-- Activate the USB connection (only if on debug mode)
if debug then System.usbDiskModeActivate() end

-- Load all the images and sounds
loadGraphics()
loadSounds()

-- Init all alien variables
loadAliens()

-- Set all of the game's variables
resetGameplay()

-- Display the game's intro and get difficulty level
displayIntro("select difficulty")

-- Draw the aliens' layer
drawAliens()

-- Draw the shields' layer
placeShields()

lPressed      = false
rPressed      = false

function gameLoop()
	-- You beat the game! ;-)
	-- (Is that even possible?)
	if level == 31 then
		beat()
		return true
	end

	-- Win if there aren't any aliens left alive
	if aliveAliens == 0 then win() end

	-- Move the aliens and make them shoot
	processAliens()
	
	-- Process alien explosions
	processExplosions()

	-- Move all bullets
	processBullets()
	
	-- Read the controls
	pad = Controls.read()
	
	-- If user presses Start,
	if pad:start() then
		local exit = false
		
		local sPress = false
		local xPress = false
		
		-- Display the message
		render("ask exit")
		
		while exit == false do
			pad = Controls.read()
			
			-- Start continues,
			if pad:start() then
				if not sPress then
					sPress = true
					break
				end
			else
				sPress = false
			end
			
			-- Cross exits game
			if pad:cross() then
				if not xPress then
					xPress = true
					exit = true
				end
			else
				xPress = false
			end
		end
		
		-- If s/he truly wants to exit, then exit
		if exit then
			cleanUp()
			return false
		end
	end
	
	-- Left
	if pad:left() then
		ship.x = ship.x - ship.speed
	end

	-- Right
	if pad:right() then
		ship.x = ship.x + ship.speed
	end

	-- Left gun shoot
	if pad:l() then
		if not lPressed then
			lPressed = true
			shoot(1)
  		end
	else
	    lPressed = false
	end

	-- Right gun shoot
	if pad:r() then
		if not rPressed then
			rPressed = true
			shoot(2)
  		end
	else
	    rPressed = false
	end

	if ship.x <= 0 then
		ship.x = ship.x + ship.speed
	elseif ship.x + ship.w >= scrWidth then
		ship.x = ship.x - ship.speed
	end

	if ship.y <= 0 then
		ship.y = ship.y + ship.speed
	elseif ship.y + ship.h >= scrHeight then
		ship.y = ship.y - ship.speed
	end

	-- Render the screen
	render(false)
	
	if _LPN_ == true then Events.Poll() end
	
	return true
end

if true then
	-- Tells whether or not the game is running
	running = true
	
	-- Run the game
	while running do
		if not gameLoop() then running = false end
	end
end
